<?php

//for dealing with salaries table
class SalaryController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        //this will boot people out if they're not logged in
        $auth = Zend_Auth::getInstance();
        if( !$auth->hasIdentity() )
        {
             // display login box
            return $this->_helper->redirector('login', 'Authorize');
        }
    }

    public function indexAction()
    {
        // action body (show salaries for an employee)
        $dbStuff = new Zend_Session_Namespace('dbStuff');
        $dbStuff->salaryCount = 0;
        if ($dbStuff->salaryPosted == false) $dbStuff->salaryForID = 0;
        $dbStuff->salaryFor = "";
        $dbStuff->salaryError = false;
        
        $salaryID = "0";
        
        //id initally comes in via get
        if(isset($_GET['idSalary']))
                if(is_numeric($_GET['idSalary']))
                    {
                        $salaryID = $_GET['idSalary'];
                        $dbStuff->salaryForID = $salaryID;
                    }
              
        //refresh ID on subsequent viewings
        //despite the name of the variable, I also mean cancelled updates
        if ($dbStuff->salaryPosted == true)
        {
            $salaryID = $dbStuff->salaryForID;
            $dbStuff->salaryPosted = false;
        }
                
        if ($salaryID == "0")
        {
            //display error, don't fetch records
            $dbStuff->salaryError = true;
        }
        
        else
        {
            //get the name of the employee
            $empmap = new Application_Model_EmployeeMapper();
            $fetchedemp = $empmap->getEmployee($salaryID);
            $dbStuff->salaryFor = $fetchedemp->getFirstName() . " " . $fetchedemp->getLastName();
            
            //fetch records for provided ID (if any)
            $salary = new Application_Model_SalaryMapper();
            //get the count
            $dbStuff->salaryCount = $salary->getCount($salaryID);
            //get the records
            $this->view->salaries = $salary->getAllSalaries($salaryID);
        }
        
    }
 

    public function updateAction()
    {
        // action body (to update salary)
        $dbStuff = new Zend_Session_Namespace('dbStuff');
        $empID = $dbStuff->salaryForID;
        $empName = $dbStuff->salaryFor;
        $count = $dbStuff->salaryCount;
        
        //if no good ID provided and not posting the update, stop
        if ($empID == 0 && !$this->getRequest()->isPost())
            return $this->_helper->redirector('index');

        //I actually need now to get an employee for this id
        $salmap = new Application_Model_SalaryMapper();
        
        $request = $this->getRequest();
        $form    = new Application_Form_SalaryUpdate();
        
        //if cancel button was pressed, we're done
        $form->populate($request->getPost());
        if ($form->cancel->isChecked())
        {
                $dbStuff->salaryPosted = true; //not really, but preserves ID
                return $this->_helper->redirector('index');
        }
        
        //if posting changes, make changes
        if ($this->getRequest()->isPost()) {
            if ($form->isValid($request->getPost())) {
                $sal = new Application_Model_Salary();
                //GET INFO FROM FIELDS
                $sal->setEmpNo($form->getValue("emp_no")); //readonly on the form
                $sal->setSalary($form->getValue("salary"));
                $mapper  = new Application_Model_SalaryMapper();
                $mapper->save($sal);
                $dbStuff->salaryPosted = true;
                return $this->_helper->redirector('index');
            }
        }
 
        //populate form
        $this->view->form = $form;
        if ($count > 0)
        {//if they have a salary already
            $fetchedsal = $salmap->getASalary($empID);
            $data = array('empName' => $empName, 'emp_no' => $fetchedsal->getEmpNo(),
            'salary' => $fetchedsal->getSalary());
        }
        else
        {//if they don't have a salary already
            $data = array('empName' => $empName, 'emp_no' => $empID,
            'salary' => 0);
        }
        $this->view->form->populate($data);
    }
}



