<?php

//form for adding employees
//"application form" means a form for the application
//not an application form in the sense of applying for a job
class Application_Form_EmployeeInsert extends Zend_Form
{

    public function init()
    {
        // Set the method for the display form to POST
        $this->setMethod('post');
 
        // Add a first name element
        $this->addElement('text', 'first_name', array(
            'label'      => 'First name:',
            'required'   => true,
            'filters'    => array('StringTrim')
        ));
 
        // Add the last name element
        $this->addElement('text', 'last_name', array(
            'label'      => 'Last name:',
            'required'   => true,
            'filters'    => array('StringTrim')
        ));
 
        //gender
        //http://zendgeek.blogspot.ca/2009/07/creating-radio-button-in-zend-framework.html
        $gender = $this->createElement('radio','gender');
        $gender->setLabel('Gender:')
            ->addMultiOptions(array(
                    'M' => 'Male',
                    'F' => 'Female' 
                        ))
            ->setAttrib("checked","checked") //selects second button, but it doesn't matter
            ->setSeparator('');  
        $this->addElement($gender);
        
        //BIRTH DATE chunks
                // Year
        $this->addElement('text', 'byear', array(
            'label'      => 'Birth Date :: Year:',
            'required'   => true,
            'style' => 'width:75px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1900, 'max' => 9999)))
        ));
                // Month
        $this->addElement('text', 'bmonth', array(
            'label'      => 'Month:',
            'required'   => true,
            'style' => 'width:40px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1, 'max' => 12)))
        ));
                // Day
        $this->addElement('text', 'bday', array(
            'label'      => 'Day:',
            'required'   => true,
            'style' => 'width:40px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1, 'max' => 31)))
        ));
        //http://zend-framework-community.634137.n4.nabble.com/Zend-Form-Decorators-Multiple-Buttons-On-One-Line-td642790.html
        $this->addDisplayGroup(array('byear', 'bmonth', 'bday'), 'birthDate', array( 
        'decorators' => array( 
            'FormElements', 
            array('HtmlTag', array('tag' => 'p', 'class' => 'element')), 
        ), 
        )); 

        //HIRE DATE chunks
                // Year
        $this->addElement('text', 'hyear', array(
            'label'      => 'Hire Date :: Year:',
            'required'   => true,
            'style' => 'width:75px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1900, 'max' => 9999)))
        ));
                // Month
        $this->addElement('text', 'hmonth', array(
            'label'      => 'Month:',
            'required'   => true,
            'style' => 'width:40px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1, 'max' => 12)))
        ));
                // Day
        $this->addElement('text', 'hday', array(
            'label'      => 'Day:',
            'required'   => true,
            'style' => 'width:40px;',
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               array('Between', false, array('min' => 1, 'max' => 31)))
        ));
        //http://zend-framework-community.634137.n4.nabble.com/Zend-Form-Decorators-Multiple-Buttons-On-One-Line-td642790.html
        $this->addDisplayGroup(array('hyear', 'hmonth', 'hday'), 'hireDate', array( 
        'decorators' => array( 
            'FormElements', 
            array('HtmlTag', array('tag' => 'p', 'class' => 'element')), 
            ),
        )); 
        
        
        // Add the insert button
        $this->addElement('submit', 'submit', array(
            'onclick'  => 'return confirm(\'Really Add?\')',
            'ignore'   => true,
            'label'    => 'Add Employee',
        ));
        
        // Add the cancel button
        $this->addElement('submit', 'cancel', array(
            'ignore'   => true,
            'label'    => 'Cancel',
        ));
 
        // And finally add some CSRF protection
        $this->addElement('hash', 'csrf', array(
            'ignore' => true,
        ));
    }


}

