<?php

//form for updating employee salaries
//"application form" means a form for the application
//not an application form in the sense of applying for a job
class Application_Form_SalaryUpdate extends Zend_Form
{

    public function init()
    {
        // Set the method for the display form to POST
        $this->setMethod('post');
        
        // Add a name element
        $this->addElement('text', 'empName', array(
            'label'      => 'Salary of:',
            'readonly'   => true
        ));
        
        // Add an id element (readonly)
        $this->addElement('text', 'emp_no', array(
            'label'      => 'Employee ID:',
            'readonly'   => true
        ));
 
        // Add a salary element
        $this->addElement('text', 'salary', array(
            'label'      => 'Salary:',
            'required'   => true,
            'filters'    => array('StringTrim'),
            'decorators' => array('Errors','Label',
            'ViewHelper'),
            'validators' => array(
               'Float',
               array('Between', false, array('min' => 0, 'max' => 999999999999)))
            //no greater than or equal to option
            //hopefully there won't be trillion-dollar salaries
        ));
 
        // Add the insert button
        $this->addElement('submit', 'submit', array(
            'onclick'  => 'return confirm(\'Really Update?\')',
            'ignore'   => true,
            'label'    => 'Update Salary',
        ));
        
        // Add the cancel button
        $this->addElement('submit', 'cancel', array(
            'ignore'   => true,
            'label'    => 'Cancel',
        ));
 
        // And finally add some CSRF protection
        $this->addElement('hash', 'csrf', array(
            'ignore' => true,
        ));
    }


}

